#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L
{
  int Key; //  .
  int Count; // .
  int WGN; // .
  Tref Trail; //   .
  Lref Next; //       .
} Leader;

//   .
typedef struct T
{
  Lref Id;
  Tref Next;
} Trailer;

//   .
typedef Lref TipElement;
typedef struct Zveno *svqz;
typedef struct Zveno
{
  TipElement Element1;
  TipElement Element2;
  svqz Sled;
} St;

int L[30]; //       L
           //    .
int num=0;

class Spisok
{
  private:
	 Lref Head; //     .
	 Lref Tail; //   
                    //    .
	 svqz Stack; //   .
	 void SearchGraph (int, Lref *);
	 void W_S (svqz *, TipElement, TipElement);
	 void UDALENIE (svqz *, TipElement *, TipElement *);
  public:
	 Spisok() {//   .
                   Head = Tail =  new (Leader); Stack = NULL;}
	 Lref GetHead() { return Head; }
	 Lref &GetHead1() { return Head; }
	 Lref GetTail() { return Tail; }
	 void MakeGraph ();
	 void PrintGraph ();
	 void TwoLink (Lref, Lref);
};

void main ()
{
  Spisok A;
  Lref SuperHead;//    .
  Lref t; //   
          //   .

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //   .
  cout << "    :\n";
  t = A.GetHead();
  while (t!=A.GetTail())
	{ (*t).WGN = 0; t = (*t).Next;}
  //     .
  SuperHead = new (Leader);
  SuperHead->Key = 0; SuperHead->Next = A.GetHead();
  A.GetHead1() = SuperHead;
  t = A.GetHead()->Next;
  while (t!=A.GetTail())
  {
	 if ( t->WGN==0 ) A.TwoLink (t,A.GetHead());
	 t = t->Next;
  }
}

void Spisok::SearchGraph (int w, Lref *h)
//     
//  w  ,      Head.
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0;
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head  
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
	  cout<<"   : "; cin>>y;
	  //,      (x,y)?
	  SearchGraph (x, &p); SearchGraph (y,&q);
	  r = (*p).Trail; Res = FALSE;
	  while ((r!=NULL)&&(!Res))
		 if ((*r).Id==q) Res = TRUE;
		 else r = (*r).Next;
	  if (!Res) //  ,     .
		{ t = new (Trailer); (*t).Id = q;
		  (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; }
	  cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,  
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
	  cout<<"("<<(*p).Key; q = (*p).Trail;
	  while (q!=NULL)
		{ cout<<(*(*q).Id).Key; q = (*q).Next; }
	  cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::W_S (svqz *stk, TipElement el1, TipElement el2)
// el1  el2   stk.
{
  svqz q=new (St);
  (*q).Element1 = el1; (*q).Element2 = el2;
  (*q).Sled = *stk; *stk = q;
}

void Spisok::UDALENIE (svqz *stk, TipElement *klad1, TipElement *klad2)
//   ,   *stk.
//     -
//   klad1  klad2.
{
  svqz q;

  if (*stk==NULL) cout<<"    !\n";
  else
	{ *klad1 = (**stk).Element1;
	  *klad2 = (**stk).Element2;
	  q = *stk; *stk = (**stk).Sled; delete q; }
}


void Spisok::TwoLink (Lref r, Lref p)
//  ,    r->Key  ,
// p      r->Key.
{
  Tref t;
  Lref e1,e2;

  num++; r->WGN = num; L[r->Key] = r->WGN;
  t = r->Trail;
  while ( t != NULL )
  {
    if ( t->Id->WGN==0 )
    {
      W_S (&Stack,r,t->Id);
      TwoLink (t->Id,r);
      if ( L[r->Key] > L[t->Id->Key] )
			L[r->Key] = L[t->Id->Key];
      if ( L[t->Id->Key] >= r->WGN )
      {
	//   .
	do {
		  UDALENIE (&Stack,&e1,&e2);
		  cout << "(" << e1->Key << " " << e2->Key << ") ";
           }
	while (!((e1->Key==r->Key && e2->Key==t->Id->Key) ||
		(e1->Key==t->Id->Key && e2->Key==r->Key)));
	cout << ";\n";
      }	
    }
    else
      if  (t->Id->Key != p->Key &&  r->WGN > t->Id->WGN)
      {
          W_S (&Stack,r,t->Id);
	  if ( L[r->Key] > t->Id->WGN )
		 L[r->Key] = t->Id->WGN;
      }
      t = t->Next;
  }
}
